

'#####################################################################################
'ADLER32, by Marc Sven Schulte, 10th July 2003.
'Note: This is the fastest implementation so far.
'
Function ADLER32(ByVal Address As Dword, _
  ByVal Length As Long, _
  ByVal Seed As Dword) As Dword
  #Register None
  ! mov edx, Seed
  ! movzx ecx, dx
  ! shr edx, 16
  ! mov esi, Address
  ! mov eax, Length
  ! add eax, esi
  ! xor ebx, ebx
  LP:
  ! mov bl, [esi]
  ! add ecx, ebx
  ! cmp ecx, 65521
  ! jb M1
  ! sub ecx, 65521
  M1:
  ! add edx, ecx
  ! cmp edx, 65521
  ! jb M2
  ! sub edx, 65521
  M2:
  ! inc esi
  ! cmp esi, eax
  ! jnz LP
  ! shl edx, 16
  ! add ecx, edx
  ! mov FUNCTION, ecx
End Function

Function PBMain() As Long
  Dim crc As Dword
  Dim str As String
  str = "Mark Adler"
  crc = 1
  crc = ADLER32(StrPtr(str), Len(str), crc)
  MsgBox "ADLER32: " & Hex$(crc, 8) & " (should be: 13070394)"
End Function
